/*
 *  Copyright 2005-2008 Fabrice Colin
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifdef WIN32
#include <windows.h>
#endif
#include <stdlib.h>
#include <pthread.h>
#include <iostream>

#ifdef USE_SSL
#include <openssl/crypto.h>
#endif

#include "DownloaderInterface.h"

using namespace std;

/// Initialize downloaders.
void DownloaderInterface::initialize(void)
{
}

/// Shutdown downloaders.
void DownloaderInterface::shutdown(void)
{
}

DownloaderInterface::DownloaderInterface() :
	m_userAgent("Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.7.3) Gecko/20041020"),
	m_proxyPort(0),
	m_timeout(60),
	m_method("GET")
{
}

DownloaderInterface::~DownloaderInterface()
{
}

/// Sets a (name, value) setting; true if success.
bool DownloaderInterface::setSetting(const string &name, const string &value)
{
	bool goodSetting = true;

	if (name == "useragent")
	{
		m_userAgent = value;
	}
	else if (name == "proxyaddress")
	{
		m_proxyAddress = value;
	}
	else if ((name == "proxyport") &&
		(value.empty() == false))
	{
		m_proxyPort = (unsigned int )atoi(value.c_str());
	}
	else if (name == "proxytype")
	{
		m_proxyType = value;
	}
	else if (name == "timeout")
	{
		m_timeout = (unsigned int)atoi(value.c_str());
	}
	else if (name == "method")
	{
		if ((value == "GET") ||
			(value == "POST"))
		{
			m_method = value;
		}
	}
	else if (name == "postfields")
	{
		m_postFields = value;
	}
	else
	{
		goodSetting = false;
	}

	return goodSetting;
}

